rebol [
	title: "Bridge Statistics"
	author: "Grard Joyez"
   purpose: {Set of Procedures extracting statistics data from bridge match
			putting them in a report file}
]
;===========================
;Determining if stand alone
;===========================
autonome?: error? try [reduce[Stats?]]
;debug-file: %trace.txt
;delete debug-file
match-sheet-build?: false	;switch to turn on the building of the match sheet

;specific named variables array: each block of folowing data will contain:
	;	first:		count of occurence
	;	second:		count of success
	;	third:		count of missed
	;	fourth: 	rate of success
	;	fifth: 		IMP yield in case of success
	;	sixth: 		IMP loss in case of defeated
	;	seventh: 	IMP left aside
	;	8th: 			Slam missed
	;	9th: 			grand slam missed

no-Comp-NS: [0 0 0 0 0 0 0 0 0]
no-Comp-EW: [0 0 0 0 0 0 0 0 0]
Comp-NS: [0 0 0 0 0 0 0 0 0]
Comp-EW: [0 0 0 0 0 0 0 0 0]
OVB-NS: [0 0 0 0 0 0 0 0 0]
OVB-EW: [0 0 0 0 0 0 0 0 0]
Manche-NS: [0 0 0 0 0 0 0 0 0]
Manche-EW: [0 0 0 0 0 0 0 0 0]
OVB-M-NS: [0 0 0 0 0 0 0 0 0]
OVB-M-EW: [0 0 0 0 0 0 0 0 0]
slam-NS: [0 0 0 0 0 0 0 0 0]
OVB-S-NS: [0 0 0 0 0 0 0 0 0]
slam-EW: [0 0 0 0 0 0 0 0 0]
OVB-S-EW: [0 0 0 0 0 0 0 0 0]
Grand-NS: [0 0 0 0 0 0 0 0 0]
Grand-EW: [0 0 0 0 0 0 0 0 0]
OVB-G-NS: [0 0 0 0 0 0 0 0 0]
OVB-G-EW: [0 0 0 0 0 0 0 0 0]
; some of these variables components will not be used in some cases

report-sheet: copy []	;contains statistical report
date-test: rejoin[now/day "/" now/month "/" Now/year]
deal-swap?: true
Somme-XiDi: to-decimal 0
Somme-Xi: to-decimal 0
Somme-Xi2: to-decimal 0
Somme-Di2: to-decimal 0
Somme-Di: to-decimal 0
Trend: 0
Estimate-error: 0
R2: 100
report: copy[]
st-trend: "0"
st-estimate: "0"
same-Contract: 0
PourCent1: 0
Same-Contract-NS-IMP: 0
Same-Contract-EW-IMP: 0
was-comp?: false
was-OVB?: false
Doubled-Contract-by-NS: 0
Doubled-Contract-by-EW: 0
RigHT-Doubled-by-NS: 0
RigHT-Doubled-by-EW: 0
Gain-Doubled-by-NS: 0
Gain-Doubled-by-EW: 0
Wrong-Doubled-by-NS: 0
Wrong-Doubled-by-EW: 0
Cost-Doubled-by-NS: 0
Cost-Doubled-by-EW: 0
Missed-Doubled-by-NS: 0
Missed-Doubled-by-EW: 0
Lost-Doubled-by-NS: 0
Lost-Doubled-by-EW: 0

Petit-Chelem-demand-NS: 0
Petit-Chelem-russi-NS: 0
Petit-Chelem-laiss-NS: 0
Pourcent3-NS: 0
Grand-Chelem-demand-NS: 0
Grand-Chelem-russi-NS: 0
Grand-Chelem-laiss-NS: 0
Pourcent4-NS: 0
Petit-Chelem-demand-EW: 0
Petit-Chelem-russi-EW: 0
Petit-Chelem-laiss-EW: 0
Pourcent3-EW: 0
Grand-Chelem-demand-EW: 0
Grand-Chelem-russi-EW: 0
Grand-Chelem-laiss-EW: 0
Pourcent4-EW: 0
slam-missed-NS: 0
slam-missed-EW: 0
Missed: 0
IMP-penalty: 0
enchres?: false 


Report-Setup: does[
	if not autonome?[if not found? find CHelp/data "Report"[append CHelp/data "Report"]]
	clear report
	if not none? Deal-Event[replace Deal-Event "]" ""]
	append/only Report ["Event: " Deal-Event date-test]
	if not autonome?[
		append/only report ["NS:" NS-Team NS-Total "IMP  Time:" NS-elapsed]
		append/only report ["EW:" EW-Team EW-Total "IMP  Time:" EW-elapsed]
	]
	append/only report ["Number of deals:" NumDonne]
	append/only report ["General Trend:" st-trend "IMP/Deal"]
	append/only report ["Variance: " st-estimate "IMP"]
	append/only report ["Confidence:" R2 "%"]
	append/only report []
	append/only report ["          NS       EW"]
	append/only report ["---- SAME CONTRACT" Same-Contract "(" PourCent1 "%)-----"]
	append/only report [" Earned: " Same-Contract-NS-IMP "IMP    "  Same-Contract-EW-IMP "IMP"]
	append/only report []
	append/only report ["------ UNCONTESTED AUCTION -------"]
	append/only report ["         " no-Comp-NS/1 "       "  no-Comp-EW/1]
	append/only report ["   made: " no-Comp-NS/3 "       "  no-Comp-EW/3]
	append/only report ["success: " no-Comp-NS/4 "%      "  no-Comp-EW/4 "%"]
	append/only report ["  yield: " no-Comp-NS/6 "IMP    "  no-Comp-EW/6 "IMP"]
	append/only report ["defeated " no-Comp-NS/7 "IMP    " no-Comp-EW/7 "IMP"]
	append/only report []
	append/only report ["------ COMPETITIVE BIDDING ---------- OVERBIDDING --------"]
	append/only report ["         " Comp-NS/1 "       "  Comp-EW/1 "               " OVB-NS/1 "            " OVB-EW/1 ]
	append/only report ["   made: " Comp-NS/3 "       "  Comp-EW/3 "               " OVB-NS/3 "            " OVB-EW/3]
	append/only report ["success: " Comp-NS/4 "%      "  Comp-EW/4 "%            " OVB-NS/4 "%          " OVB-EW/4 "%"]
	append/only report ["  yield: " Comp-NS/6 "IMP    "  Comp-EW/6 "IMP           " OVB-NS/6 "IMP        " OVB-EW/6 "IMP"]
	append/only report ["defeated " Comp-NS/7 "IMP    " Comp-EW/7 "IMP           " OVB-NS/7 "IMP        " OVB-EW/7 "IMP"]
	append/only report []
	append/only report ["------- DOUBLING RELEVANCE -------"]
	append/only report ["         " Doubled-Contract-by-NS "       "  Doubled-Contract-by-EW]
	append/only report ["  right: " RigHT-Doubled-by-NS "       "  RigHT-Doubled-by-EW ]
	append/only report ["   Gain: " Gain-Doubled-by-NS "IMP    "  Gain-Doubled-by-EW "IMP"]
	append/only report ["  Wrong: " Wrong-Doubled-by-NS "       "  Wrong-Doubled-by-EW ]
	append/only report ["   Cost: " Cost-Doubled-by-NS "IMP    "  Cost-Doubled-by-EW "IMP"]
	append/only report [" missed: " Missed-Doubled-by-NS "       "  Missed-Doubled-by-EW ]
;	append/only report ["   lost: " Lost-Doubled-by-NS "IMP    "  Lost-Doubled-by-EW "IMP"]
	append/only report []
	append/only report ["----------     BONUSES    --------"]
	append/only report ["           GAME"]
	append/only report [" called: " Manche-NS/2 "       "  Manche-EW/2 "               " OVB-M-NS/2 "            " OVB-M-EW/2]
	append/only report ["   made: " Manche-NS/3 "       "  Manche-EW/3 "               " OVB-M-NS/3 "            " OVB-M-EW/3]
	append/only report ["   rate: " Manche-NS/4 "%      "  Manche-EW/4 "%              " OVB-M-NS/4 "%           " OVB-M-EW/4 "%"]
	append/only report [" missed: " Manche-NS/5 "       "  Manche-EW/5  ]
	append/only report []
	append/only report ["            SLAM"]
	append/only report [" called: " slam-NS/2 "       "  slam-EW/2 "               "  OVB-S-EW/2 "            "  OVB-S-EW/2]
	append/only report ["   made: " slam-NS/3 "       "  slam-EW/3 "               "  OVB-S-EW/2 "            "  OVB-S-EW/2]
	append/only report ["   rate: " slam-NS/4 "%      "  slam-EW/4 "%              "  OVB-S-EW/2 "            "  OVB-S-EW/2 "%"]
	append/only report [" missed: " slam-missed-NS "       "  slam-missed-EW ]
	append/only report []
	append/only report ["          GRAND SLAM"]
	append/only report [" called: " Grand-NS/2 "       "  Grand-EW/2 "               "  OVB-G-EW/2 "            "  OVB-G-EW/2]
	append/only report ["   made: " Grand-NS/3 "       "  Grand-EW/3 "               "  OVB-G-EW/3 "            "  OVB-G-EW/3]
	append/only report ["   rate: " Grand-NS/4 "%      "  grand-EW/4 "               "  OVB-G-EW/4 "            "  OVB-G-EW/4 "%"]
	append/only report [" missed: " Grand-missed-NS "       "  Grand-missed-EW ]
]
Tronquer: func[ X  D [integer!]/local s exposant][	;rounds a decimal to a limited number of digits
	s: to-string X
	either found? find s #"E"[
		either 0.01 >= absolute x [
			s: join first s find s #"E"
			][
			clear find s #"E"
			replace s "." ""
			s: either X > 0 [join ".0" copy/part s 2][join "-.0" copy/part skip s 1 2] 
		]
		][
		if found? find s "."[head clear skip find s "." (D + 1)]
	]
	s
]
MAJour: func[
;paving/incrementing variables components
	Lref	[integer!]
	MD [block!]
	/times
	/Win I [integer!]
	][
	if times[MD/1: MD/1 + 1]				;total count
	either Lref < Level[
		MD/2: MD/2 + 1						;count of met conditions
		if Rsultat >= 0[MD/3: MD/3 + 1]	;count of success
		MD/4: to-integer (100 * MD/3 / MD/2);rate of success
		if Level < 6[if (Rsultat + Level) = 6[MD/8: MD/8 + 1 ]]
		if Level < 7[if (Rsultat + Level) = 7[MD/9: MD/9 + 1]]
		][
		either (Rsultat + Level)< 6[
			if (Rsultat + Level) > Lref[MD/5: MD/5 + 1];count of missed (forgotten)
			][
			either (Rsultat + Level) = 6[MD/8: MD/8 + 1 ][MD/9: MD/9 + 1]
		]
	]
	if Win [either rsultat >= 0[MD/6: MD/6 + I][MD/7: MD/7 + I]];impact in IMP of win or loss
	reduce MD
]

;====================
;computing trend standard deviation from a linear model and level of relevance of the linear model
;====================
stats: does[
	N: NumDonne
	Somme-XiDi: Somme-XiDi + ((NS-Total - EW-Total) * NumDonne)
	Somme-Di: Somme-Di + NS-Total - EW-Total
	Somme-Di2: Somme-Di2 + ((NS-Total - EW-Total) ** 2)
	Somme-Xi: Somme-Xi + NumDonne
	Somme-Xi2: Somme-Xi2 + (NumDonne ** 2)
	dnominateur: (N * Somme-Xi2) - (Somme-xi * somme-xi)
	if dnominateur <> 0[Trend: ((N * Somme-XiDi) - (Somme-xi * Somme-Di)) / dnominateur]
	b0: (somme-di - (trend * somme-xi)) / NumDonne
	Sum-Square-roots: (trend * trend * Somme-Xi2) - (2 * trend * Somme-XiDi) + Somme-Di2
	add-offset: (2 * trend * b0 * somme-xi) + (numDonne * B0 * b0) - (2 * b0 * somme-di)
	Sum-Square-roots: Sum-Square-roots + add-offset
	if NumDonne > 2[Ecart-type-rsiduel: square-root(Sum-Square-Roots / (NumDonne - 2))
		Estimate-error: Ecart-type-rsiduel
		dnominateur: Somme-Di2 - ((Somme-Di ** 2) / NumDonne)
		IF dnominateur > 0[
			R2: to-integer ((1 - (Sum-Square-roots / dnominateur)) * 100)
			if R2 < 0 [R2: 0]
		]
	]
	R: parse g none
	C1: replace/all copy Contract "X" ""
	C2: replace/all copy first-round-contract "X" ""
	IMP-Diff: NS-IMP - EW-IMP
	if (trim C1) = (trim c2)[
		Same-Contract: Same-Contract + 1
		PourCent1: to-integer ((Same-Contract / NumDonne) * 100)
		Same-Contract-NS-IMP: Same-Contract-NS-IMP + NS-IMP
		Same-Contract-EW-IMP: Same-Contract-EW-IMP + EW-IMP
	] 
	If ("Pass" <> trim C2) and ("SKIP" <> C2)[
		rsultat: fifth R
		if rsultat = "=" [rsultat: 0]
		rsultat: to-integer rsultat
		level: to-integer to-string first C2
		either was-comp?[
			switch fourth R[
				"N" [either OVB?[OVB-NS: MAJour/times/Win 0 OVB-NS IMP-Diff][Comp-NS: MAJour/times/Win 0 Comp-NS IMP-Diff]]
				"S" [either OVB?[OVB-NS: MAJour/times/Win 0 OVB-NS IMP-Diff][Comp-NS: MAJour/times/Win 0 Comp-NS IMP-Diff]]
				"E" [either OVB?[OVB-EW: MAJour/times/Win 0 OVB-EW (- IMP-Diff)][Comp-EW: MAJour/times/Win 0 Comp-EW (- IMP-Diff)]]
				"W" [either OVB?[OVB-EW: MAJour/times/Win 0 OVB-EW (- IMP-Diff)][Comp-EW: MAJour/times/Win 0 Comp-EW (- IMP-Diff)]]
				"O" [either OVB?[OVB-EW: MAJour/times/Win 0 OVB-EW (- IMP-Diff)][Comp-EW: MAJour/times/Win 0 Comp-EW (- IMP-Diff)]]
			]
			][
			switch fourth R[
				"N" [no-Comp-NS: MAJour/times/Win 0 no-Comp-NS IMP-Diff]
				"S" [no-Comp-NS: MAJour/times/Win 0 no-Comp-NS IMP-Diff]
				"E" [no-Comp-EW: MAJour/times/Win 0 no-Comp-EW (- IMP-Diff)]
				"W" [no-Comp-EW: MAJour/times/Win 0 no-Comp-EW (- IMP-Diff)]
				"O" [no-Comp-EW: MAJour/times/Win 0 no-Comp-EW (- IMP-Diff)]
			]
		]
	]
	If ("Pass" <> trim C1) and ("SKIP" <> C1)[
		level: to-integer to-string first C1
		OVB?: very-Comp?
		rsultat: rel-result
		either comp?[
			switch Declarer[
				"N" [either OVB?[OVB-NS: MAJour/times/Win 0 OVB-NS IMP-Diff][Comp-NS: MAJour/times/Win 0 Comp-NS IMP-Diff]]
				"S" [either OVB?[OVB-NS: MAJour/times/Win 0 OVB-NS IMP-Diff][Comp-NS: MAJour/times/Win 0 Comp-NS IMP-Diff]]
				"E" [either OVB?[OVB-EW: MAJour/times/Win 0 OVB-EW (- IMP-Diff)][Comp-EW: MAJour/times/Win 0 Comp-EW (- IMP-Diff)]]
				"W" [either OVB?[OVB-EW: MAJour/times/Win 0 OVB-EW (- IMP-Diff)][Comp-EW: MAJour/times/Win 0 Comp-EW (- IMP-Diff)]]
				"O" [either OVB?[OVB-EW: MAJour/times/Win 0 OVB-EW (- IMP-Diff)][Comp-EW: MAJour/times/Win 0 Comp-EW (- IMP-Diff)]]
			]
			][
			switch Declarer[
				"N" [no-Comp-NS: MAJour/times/Win 0 no-Comp-NS IMP-Diff]
				"S" [no-Comp-NS: MAJour/times/Win 0 no-Comp-NS IMP-Diff]
				"E" [no-Comp-EW: MAJour/times/Win 0 no-Comp-EW (- IMP-Diff)]
				"W" [no-Comp-EW: MAJour/times/Win 0 no-Comp-EW (- IMP-Diff)]
				"O" [no-Comp-EW: MAJour/times/Win 0 no-Comp-EW (- IMP-Diff)]
			]
		]
	]

;	if ((trim contract) <> "Pass") and (contract <> "SKIP") [analyse-contre]
	analyse-contre
	BONUS-stats
	clear report-sheet
	st-trend: tronquer trend 2
	st-estimate: tronquer estimate-error 2
	slam-missed-NS:  comp-NS/8 + no-comp-NS/8 + OVB-NS/8
	grand-missed-NS: comp-NS/9 + no-comp-NS/9 + OVB-NS/9
	slam-missed-EW:  comp-EW/8 + no-comp-EW/8 + OVB-EW/8
	grand-missed-EW: comp-EW/9 + no-comp-EW/9 + OVB-EW/9
	Foreach r report[append report-sheet form reduce r ]
]
analyse-contre: does[
if (C2 <> "SKIP") and (C2 <> "Pass") [
	rsultat: fifth R
	if rsultat = "=" [rsultat: 0]
	rsultat: to-integer rsultat
	either rsultat >= 0[
		if found? find (third R) "X"[
			switch fourth R[
				"N" [Doubled-Contract-by-EW: Doubled-Contract-by-EW + 1
						Cost-Doubled-by-EW: Cost-Doubled-by-EW - IMP-Diff
						Wrong-Doubled-by-EW: Wrong-Doubled-by-EW + 1
					]
				"S" [Doubled-Contract-by-EW: Doubled-Contract-by-EW + 1
						Cost-Doubled-by-EW: Cost-Doubled-by-EW - IMP-Diff
						Wrong-Doubled-by-EW: Wrong-Doubled-by-EW + 1
					]
				"E" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
						Cost-Doubled-by-NS: Cost-Doubled-by-NS + IMP-Diff
						Wrong-Doubled-by-NS: Wrong-Doubled-by-NS + 1
					]
				"W" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
						Cost-Doubled-by-NS: Cost-Doubled-by-NS + IMP-Diff
						Wrong-Doubled-by-NS: Wrong-Doubled-by-NS + 1
					]
				"O" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
						Cost-Doubled-by-NS: Cost-Doubled-by-NS + IMP-Diff
						Wrong-Doubled-by-NS: Wrong-Doubled-by-NS + 1
					]
				]
				IMP-Diff: 0	;clear to avoid double accounting in case of
			]
			][
			Either found? find (third R) "X"[
				switch fourth R[
					"N" [Doubled-Contract-by-EW: Doubled-Contract-by-EW + 1
							Gain-Doubled-by-EW: Gain-Doubled-by-EW - IMP-Diff
							Right-Doubled-by-EW: Right-Doubled-by-EW + 1
						]
					"S" [Doubled-Contract-by-EW: Doubled-Contract-by-EW + 1
							Gain-Doubled-by-EW: Gain-Doubled-by-EW - IMP-Diff
							Right-Doubled-by-EW: Right-Doubled-by-EW + 1
						]
					"E" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
							Gain-Doubled-by-NS: Gain-Doubled-by-NS + IMP-Diff
							Right-Doubled-by-NS: Right-Doubled-by-NS + 1
						]
					"W" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
							Gain-Doubled-by-NS: Gain-Doubled-by-NS + IMP-Diff
							Right-Doubled-by-NS: Right-Doubled-by-NS + 1
						]
					"O" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
							Gain-Doubled-by-NS: Gain-Doubled-by-NS + IMP-Diff
							Right-Doubled-by-NS: Right-Doubled-by-NS + 1
						]
					]
				IMP-Diff: 0	;clear to avoid double accounting in case of
				][
				switch fourth R[
					"N" [Lost-Doubled-by-EW: Lost-Doubled-by-EW - IMP-Diff
							Missed-Doubled-by-EW: Missed-Doubled-by-EW + 1
						]
					"S" [Lost-Doubled-by-EW: Lost-Doubled-by-EW - IMP-Diff
							Missed-Doubled-by-EW: Missed-Doubled-by-EW + 1
						]
					"E" [Lost-Doubled-by-NS: Lost-Doubled-by-NS + IMP-Diff
							Missed-Doubled-by-NS: Missed-Doubled-by-NS + 1
						]
					"W" [Lost-Doubled-by-NS: Lost-Doubled-by-NS + IMP-Diff
							Missed-Doubled-by-NS: Missed-Doubled-by-NS + 1
						]
					"O" [Lost-Doubled-by-NS: Lost-Doubled-by-NS + IMP-Diff
							Missed-Doubled-by-NS: Missed-Doubled-by-NS + 1
						]
				]
			]
		]
	]
if (C1 <> "SKIP") and (C1 <> "Pass") [
	either rel-result >= 0[
		if found? find Contract "X"[
			switch Declarer[
				"N" [Doubled-Contract-by-EW: Doubled-Contract-by-EW + 1
						Cost-Doubled-by-EW: Cost-Doubled-by-EW - IMP-Diff
						Wrong-Doubled-by-EW: Wrong-Doubled-by-EW + 1
					]
				"S" [Doubled-Contract-by-EW: Doubled-Contract-by-EW + 1
						Cost-Doubled-by-EW: Cost-Doubled-by-EW - IMP-Diff
						Wrong-Doubled-by-EW: Wrong-Doubled-by-EW + 1
					]
				"E" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
						Cost-Doubled-by-NS: Cost-Doubled-by-NS + IMP-Diff
						Wrong-Doubled-by-NS: Wrong-Doubled-by-NS + 1
					]
				"W" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
						Cost-Doubled-by-NS: Cost-Doubled-by-NS + IMP-Diff
						Wrong-Doubled-by-NS: Wrong-Doubled-by-NS + 1
					]
				"O" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
						Cost-Doubled-by-NS: Cost-Doubled-by-NS + IMP-Diff
						Wrong-Doubled-by-NS: Wrong-Doubled-by-NS + 1
					]
				]
			]
			][
			Either found? find Contract "X"[
				switch Declarer[
					"N" [Doubled-Contract-by-EW: Doubled-Contract-by-EW + 1
							Gain-Doubled-by-EW: Gain-Doubled-by-EW + IMP-Diff
							Right-Doubled-by-EW: Right-Doubled-by-EW + 1
						]
					"S" [Doubled-Contract-by-EW: Doubled-Contract-by-EW + 1
							Gain-Doubled-by-EW: Gain-Doubled-by-EW + IMP-Diff
							Right-Doubled-by-EW: Right-Doubled-by-EW + 1
						]
					"E" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
							Gain-Doubled-by-NS: Gain-Doubled-by-NS - IMP-Diff
							Right-Doubled-by-NS: Right-Doubled-by-NS + 1
						]
					"W" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
							Gain-Doubled-by-NS: Gain-Doubled-by-NS - IMP-Diff
							Right-Doubled-by-NS: Right-Doubled-by-NS + 1
						]
					"O" [Doubled-Contract-by-NS: Doubled-Contract-by-NS + 1
							Gain-Doubled-by-NS: Gain-Doubled-by-NS - IMP-Diff
							Right-Doubled-by-NS: Right-Doubled-by-NS + 1
						]
				]
				][
				switch Declarer[
					"N" [Lost-Doubled-by-EW: Lost-Doubled-by-EW - IMP-Diff
							Missed-Doubled-by-EW: Missed-Doubled-by-EW + 1
						]
					"S" [Lost-Doubled-by-EW: Lost-Doubled-by-EW - IMP-Diff
							Missed-Doubled-by-EW: Missed-Doubled-by-EW + 1
						]
					"E" [Lost-Doubled-by-NS: Lost-Doubled-by-NS + IMP-Diff
							Missed-Doubled-by-NS: Missed-Doubled-by-NS + 1
						]
					"W" [Lost-Doubled-by-NS: Lost-Doubled-by-NS + IMP-Diff
							Missed-Doubled-by-NS: Missed-Doubled-by-NS + 1
						]
					"O" [Lost-Doubled-by-NS: Lost-Doubled-by-NS + IMP-Diff
							Missed-Doubled-by-NS: Missed-Doubled-by-NS + 1
						]
				]
			]
		]
	]
]
stats1: does[
;saving first round param and setting second round params
	was-comp?: comp?
	OVB?: very-Comp?
	was-OVB?: OVB?
	bonus-stats
]
Bonus-manche: func[
	MD [bLOCK!]
	][
	either found? find Contract "N"[
		MAJour 2 MD
		][
		major?: (found? find Contract "H") or (found? find Contract "S")
		either major?[MAJour 3 MD][MAJour 4 MD ]
	]
	reduce MD
]
bonus-stats: does[
	if contract = "Pass" [exit]
	if contract = "SKIP" [exit]
	rsultat: either rel-result = "=" [0][to-integer rel-result]
	level: to-integer to-string first contract
	either level < 6[
		switch Declarer[
			"N" [either OVB?[OVB-M-NS: Bonus-Manche OVB-M-NS][Manche-NS: Bonus-Manche Manche-NS]]
			"S" [either OVB?[OVB-M-NS: Bonus-Manche OVB-M-NS][Manche-NS: Bonus-Manche Manche-NS]]
			"E" [either OVB?[OVB-M-EW: Bonus-Manche OVB-M-EW][Manche-EW: Bonus-Manche Manche-EW]]
			"W" [either OVB?[OVB-M-EW: Bonus-Manche OVB-M-EW][Manche-EW: Bonus-Manche Manche-EW]]
			"O" [either OVB?[OVB-M-EW: Bonus-Manche OVB-M-EW][Manche-EW: Bonus-Manche Manche-EW]]
		]
		][
		switch Declarer[
			"N" [either 6 = level[MAJour 5 slam-NS][MAJour 6 grand-NS]]
			"S" [either 6 = level[MAJour 5 slam-NS][MAJour 6 grand-NS]]
			"E" [either 6 = level[MAJour 5 slam-EW][MAJour 6 grand-EW]]
			"W" [either 6 = level[MAJour 5 slam-EW][MAJour 6 grand-EW]]
			"O" [either 6 = level[MAJour 5 slam-EW][MAJour 6 grand-EW]]
		]
	]
]
is-comp?: func[E [block!] /local a b][
	b: false
	forall e[if found? find first E "=" [b: true remove E]]
	e: head E
	base-contrat: replace/all copy contract "X" ""
	pointeur: index? find E base-contrat
	z: copy[false false false]
	poke z 2 switch/default pointeur [
		1 [false]
		2 [is-very-comp? first E] 
		3 [is-very-comp? second E] 
	][(is-very-comp? pick E (pointeur - 1)) or (is-very-comp? pick E (pointeur - 3))]
	if odd? pointeur[E: copy skip E 1]
	forskip E 2[
		switch/default first E[
			"pass" [a: false]
			"X" [a: false]
			"XX" [a: false]
		][a: true break]
	]
	poke z 1 a
	poke z 3 b
	return z
]
is-very-comp?: func[
	a [string!]	
	][
	if a = "Pass" [return false]
	if found? find a "X"[return false]
	if "3NT" = a[return true]
	return (3 < (to-integer to-string first a))
]
excuter-stats: func[
	deals	[block!]
	/local 
	first-round? [logic!]
	nouveau? [logic!]
	][
	enchres-lues: copy []
	enchres?: false
	first-round?: true
	foreach l deals[
		either "" = trim/all copy l [
			if (enchres-lues <> [])[
				if enchres?[append enchres-lues parse l none]
				either first-round?[aller-record first-round?: false][retour-record first-round?: true
]
				]
				enchres?: false
				clear head enchres-lues
			][
			either enchres?[
				either found? find l "SKIP" [ ;in case of giving up before end of auction
					Contract: "Skip"
					Declarer: third parse copy l none 
					IMP-penalty: to-integer replace last parse copy l none "}" ""
					clear head enchres-lues
					enchres?: false
					][ 
					either found? find l Dbut-Crochet[enchres?: false][append enchres-lues parse l none ]
				]
				][
				if found? find l "Contract"[parse l [thru { "} copy contract to {"}]]
				if found? find l "Declarer" [parse l [thru { "} copy Declarer to {"}]]
				if found? find l "Vulnerable" [parse l [thru { "} copy Vulnerable to {"}]]
				if found? find l "Result" [parse l [thru { "} copy Result to {"}]]
				if found? find l "Auction" [enchres?: true]
				if found? find l "SKIP" [ ;in case of giving up before end of auction
					clear head enchres-lues 
					enchres?: false
					Contract: "Skip"
					Declarer: third parse copy l none
					IMP-penalty: to-integer replace last parse copy l none "}" "" 
				]
			]
		]
	]
	if enchres-lues <> [][either first-round?[aller-record][retour-record]clear head enchres-lues]
]
aller-record: does[
	if not autonome?[
		com-zone/text: join "Deal #" NumDonne
		show com-zone
	]
	R: reduce[NumDonne Vulnerable]
	first-round-contract: copy contract
	either contract = "Pass"[
		append r "Pass All = 0" 
		g: form R
		stats1
		enchres-lues: copy []
		][
		either contract = "SKIP"[
			append r rejoin ["SKIP " Declarer " = 0"]
			g: form R
			stats1
			clear head enchres-lues
			][
			Niveau-Contrat: to-integer to-string first contract
			Rel-result: (to-integer result) - 6 - Niveau-Contrat
			declarer-seat: (index? find Joueurs declarer) - 1
			append R reduce [contract declarer rel-result switch/default declarer["N" [marque] "S" [marque]][- marque]]
			Comp?: is-comp? enchres-lues
			alerted?: third comp?
			very-comp?: second comp?
			comp?: first comp?
			g: form R
			stats1
		]
	]
	if match-sheet-build?[first-round-record]
	clear head enchres-lues
]
retour-record: does[
	either contract = "Pass"[
		rel-result: 0
		Contrat: copy contract
		NS-IMP: EW-IMP: 0
		stats
		enchres-lues: copy []
		clear head enchres-lues
		][
		either contract = "SKIP"[
			rel-result: 0
			NS-IMP: EW-IMP: 0
			either deal-swap?[
				either Declarer = "EW" [NS-Total: NS-Total + NS-IMP: IMP-penalty][EW-Total: EW-Total + EW-IMP: IMP-penalty]
				][
				either Declarer = "EW" [EW-Total: EW-Total + EW-IMP: IMP-penalty][NS-Total: NS-Total + NS-IMP: IMP-penalty]
			]
			stats
			enchres-lues: copy []
			clear head enchres-lues
			][
			if autonome?[if not deal-swap?[Declarer: switch/default Declarer["S" ["W"] "N" ["E"]]["S"]]]
			Niveau-Contrat: to-integer to-string first contract
			Rel-result: (to-integer result) - 6 - Niveau-Contrat
			declarer-seat: (index? find Joueurs declarer) - 1
			diff: (to-integer pick R 6) + switch/default declarer["N" [marque] "S" [marque]][- marque]
			either diff > 0 [
				NS-IMP: IMP diff
				EW-IMP: 0
				][
				EW-IMP: IMP (- diff)
				NS-IMP: 0
			]
			NS-Total: NS-Total + NS-IMP
			EW-Total: EW-Total + EW-IMP
			Comp?: is-comp?  enchres-lues
			alerted?: third comp?
			very-comp?: second comp?
			comp?: first comp?
			contrat: copy contract
			stats
		]
		enchres-lues: copy []
	]
	if match-sheet-build?[second-round-record]
	clear head enchres-lues
	NumDonne: NumDonne + 1
	if autonome?[second-comment/text: join "Deal# " NumDonne show second-comment]
]
;==============================================================================
; STAND ALONE MODE: the following functions are used only for stand alone processing
;==============================================================================
if autonome?[
Dbut-Crochet: "["
Fin-Crochet: "]"
alerted?: false
;==========================
; IMP scoring
;==========================
IMP: func[
; compute the imp for a given score difference
	D [integer!]
	][
	if D > 3990 [return 24]
	imp-points: head imp-points 
	forall imp-points [if D < first imp-Points [return (index? imp-points) - 2]]
]
IMP-points: copy [0 20 50 90 130 170 220 270 320 370 430 500 600 750 900 1100 1300 1500 1750 2000 2250 2500 3000 3500 4000]

;=============================
; Formatting match sheet
;=============================
Match-Setup: does[
	match: copy []
	foreach l texte[
		if found? find l "North"[parse L[thru {"} copy N to {"}]]
		if found? find l "South"[parse L[thru {"} copy S to {"}]]
		if found? find l "West"[parse L[thru {"} copy W to {"}]]
		if found? find l "East"[parse L[thru {"} copy E to {"}]]
		if found? find l "Event"[parse l[thru { } copy deal-event to Fin-Crochet]]
	]
	NS-team: either N = S[N][rejoin [S "_" N]]
	EW-team: either W = E[W][rejoin [E "_" W]]
	append match rejoin["Event: " Deal-Event]
	g: join "Team 1  NS: " NS-Team
	cale-text g 45 "IMP: 0"
	cale-text g 68 "Total Time: 0"
	append match g
	g: join "Team 2  EW: " EW-Team
	cale-text g 45 "IMP: 0"
	cale-text g 68 "Total Time: 0"
	append match g
	team1: copy/part NS-team 7
	team2: copy/part EW-team 7
	while [7 > length? team1][append team1 " "]
	while [7 > length? team2][append team2 " "]
	append match "BOARD VULN.  CONTR  BY RESULT NS-Score| CONTR BY RESULT NS-Score|Team 1|Team 2|"
	write/lines Match-sheet match
]
Marque: does [
; first determine if the declarer is vulnerable
	V-Decl?: to-logic False
	Switch Vulnerable [
		{"All"}	[V-Decl?: to-logic true]
		{"Both"}	[V-Decl?: to-logic true]
		{"EW"}	[if (Declarer-seat // 2 = 1) [V-Decl?: to-logic true]]
		{"NS"}	[if (Declarer-seat // 2 = 0) [V-Decl?: to-logic true]]
		"All"		[V-Decl?: to-logic true]
		"Both"	[V-Decl?: to-logic true]
		"EW"		[if (Declarer-seat // 2 = 1) [V-Decl?: to-logic true]]
		"NS"		[if (Declarer-seat // 2 = 0) [V-Decl?: to-logic true]]
	]
	Surcontre?: to-logic false
	if contre?: found? find Contract #"X" [Surcontre?: found? find Contract "XX"]
	Col: to-string second Contract
	Contract-level: to-integer to-string first Contract
	N0: Contract-level * (switch Col ["C" 20 "D" 20 "H" 30 "S" 30 "N" 30])
	if Col = "N" [N0: N0 + 10]
	If contre? [N0: N0 * 2 if surcontre? [N0: N0 * 2]]
	Rel-result: (to-integer result) - 6 - Contract-level
	either Rel-Result >= 0 [		; successful contract
		either N0 < 100 [Prime: 50][either V-Decl? [Prime: 500][Prime: 300]]
		Prime-Chelem: 0
		If Contract-level = 6 [Prime-Chelem: either V-Decl? [750][500]]
		If Contract-level = 7 [Prime-Chelem: either V-Decl? [1500][1000]]
		M: N0 + Prime + Prime-Chelem
		eitHer Contre? [
			M: M + 50 + (Rel-Result * 100)
			if V-Decl? [M: M + (Rel-Result * 100)]
			if Surcontre? [
				M: M + 50 + (Rel-result * 100)
				if V-Decl? [M: M + (Rel-Result * 100)]
			]
			][
			M: M + (Rel-Result * (switch Col ["C" 20 "D" 20 "H" 30 "S" 30 "N" 30]))
		]
		][				; contrat chuts
		M: rel-Result * Either V-decl? [100][50]
		if Contre? [
			M: M * 2 + ((Rel-Result + 1) * 100)
			if Rel-Result < -3 [if not V-Decl? [M: M + ((Rel-Result + 3) * 100)]]
		]
		If SurContre? [M: M * 2]
	]
	return M	 
]
Reprer-donnes: does[
"indexe les donnes pbn dans un texte"
	ND: Copy []
	K: 0
	LigneVide?: to-logic true
	foreach C texte [
		K: K + 1
		D: copy C
		D: replace/all D " " ""
		D: replace/all D {tab} ""
		either D = "" [
			LigneVide?: to-logic true
			][
			if LigneVide? [LigneVide?: to-logic False append ND K]
		]
	]
	return ND
]
; where log files might be not properly sorted

ranger-donnes: func [
{put second round play just after first round}
	t [block!]
	/local result [block!]
	deal [string!]
	chaine [string!]
	][
	pointeurs: reprer-donnes
	if  3 > length? pointeurs [return T]
	cherche-pointeurs: copy pointeurs	;working list of pointers to be removed when processed
	t-hash: to-hash t
	seconde-donne?: true
	pointeur-principal: first pointeurs
	Result: copy []
	forall pointeurs[
		if found? find cherche-pointeurs first pointeurs[
			for K first pointeurs second pointeurs 1[
				chaine: copy pick t  K
				if none? deal-event[if found? find Chaine "Event"[parse chaine[thru { } copy deal-event to {]}]]]
				if found? find Chaine "Deal "[
					Deal: copy chaine
					second-comment/text: join "Deal# " NumDonne
					show main
					NumDonne: Numdonne + 1
					break
				]
			]
			append result copy/part skip T ((first pointeurs) - 1) ((second pointeurs) - first pointeurs)
			either deal-swap?: not found? find (skip t-hash second pointeurs) Deal[
				switch first second parse deal none[
					#"N" [poke deal 8 #"E"]
					#"E" [poke deal 8 #"S"]
					#"S" [poke deal 8 #"W"]
					#"W" [poke deal 8 #"N"]
				]
				either found? find (skip t-hash second pointeurs) Deal[
					Pointeur: index? find (skip t-hash second pointeurs) deal
					][
					switch first second parse deal none[
						#"N" [poke deal 8 #"W"]
						#"E" [poke deal 8 #"N"]
						#"S" [poke deal 8 #"E"]
						#"W" [poke deal 8 #"S"]
					]
					Pointeur: index? find (skip t-hash second pointeurs) deal
				]
				][
				Pointeur: index? find (skip t-hash second pointeurs) deal
			]
			forall cherche-pointeurs[
				if Pointeur < first cherche-pointeurs[
					P1: first back cherche-pointeurs
					L: (first cherche-Pointeurs) - P1
					break
				]
			]
			either tail? cherche-pointeurs[
				append result copy skip t (p1 - 1)
				][
				append result copy/part skip t (P1 - 1) L
			]
			cherche-pointeurs: head cherche-pointeurs
			remove cherche-pointeurs
			remove find cherche-pointeurs P1
			if (length? cherche-pointeurs) < 2 [break]
		]
	]
	return result
]
Joueurs: ["S" "W" "N" "E"]
;==========================
; column alignment for match sheet
;==========================
Cale-Text: func[
	T	[String!] ;Text to be cosntructed and aligned
	K	[integer!] ;alignment of added item
	S	[string!]  ;item to add
	][
	x: K - (length? T) - length? S
	for N 1 X 1[append T " "]
	append T S
]
tabulations: copy[4 10 17 22 28 35 45 48 53 62 70 77]
first-round-record: does[
	first-round-contract: copy contract
	either contract = "Pass"[
		Contrat: "Pass" Declarer: " All" Rel-result: 0 Score: 0
		][
		score: marque
	]
	if (declarer = "W") or (declarer = "E") [score: - score]
	if vulnerable = "neither"[Vulnerable: "None"]
	if vulnerable = "Both"[Vulnerable: "All"]
	g: copy ""
	either deal-swap?[
		cale-text g (pick tabulations 1) to-string NumDonne
		][
		cale-text g (pick tabulations 1) to-string NumDonne
	]
	cale-text g (pick tabulations 2) vulnerable 
	append g "|"
	cale-text g (pick tabulations 3) Contract
	cale-text g (pick tabulations 4) Declarer
	cale-text g (pick tabulations 5) (either Rel-result < 0 [
		to-string Rel-result
		][
		either rel-result > 0 [join "+" rel-result][" ="]
	])
	cale-text g (pick tabulations 6) either score < 0 [(to-string score)][join " " (to-string score)]
	z: copy either comp?[either very-Comp?["   +"]["   ?"]]["   |"]
	if alerted? [poke z 3 #"!"]
	append g z
	append match g
]
second-round-record: does[
	either contract = "Pass"[
		Contrat: "Pass" Declarer: " All" Rel-result: 0 Score: 0
		][
		score: marque
		if (declarer = "W") or (declarer = "E") [score: - score]
	]
	fin-g: copy ""
	if 39 < length? g[
		if found? find skip g 39 "SKIP"[exit]
		if found? find g "SKIP"[fin-g: copy skip g 65]
		G: copy/part g 39 poke match (NumDonne + 4) g
	]
	either fin-g =""[
		R: parse g none
		diff: (to-integer pick R 6) + either deal-swap? [score][- score]
		either diff > 0 [
			NS-IMP: IMP diff
			EW-IMP: 0
			][
			EW-IMP: IMP (- diff)
			NS-IMP: 0
		]
		][
		R: parse fin-g none
		NS-IMP: to-integer first R
		EW-IMP: to-integer third R
	]
	P: head clear find second match "IMP:"
	cale-text P 40 ""
	append P rejoin["IMP: " NS-Total ]
	cale-text P 55 ""
	poke match 2 P
	P: head clear find third match "IMP:"
	cale-text P 40 ""
	append P rejoin["IMP: " EW-Total ]
	cale-text P 55 ""
	poke match 3 P
	cale-text g (pick tabulations 7) Contract
	cale-text g (pick tabulations 8) Declarer
	cale-text g (pick tabulations 9) (either Rel-result < 0 [
		to-string Rel-result
		][
		either rel-result > 0 [join "+" rel-result][" ="]
	])
	cale-text g (pick tabulations 10) either score < 0 [(to-string score)][join " " (to-string score)]
	z: copy either comp?[either very-Comp?["   +"]["   ?"]]["   |"]
	if alerted? [poke z 3 #"!"]
	append g z
	cale-text g (pick tabulations 11) to-string NS-IMP
	append g " |"
	cale-text g (pick tabulations 12) to-string EW-IMP
	append g " |"
]

;=========================================================================
deal-analyze: does[
	hide bt-choix
	nom-fichier: request-file/only/keep/filter "*.pbn"
	a: modified? nom-fichier
	date-test: rejoin[a/day "/" a/month "/" a/year]
	reconnu?: false
	texte: read/lines nom-fichier
	deal-event: none
	if chk/data [
		match-sheet-build?: true	;switch to turn on the building of the match sheet
		match-sheet: %"match sheet.txt"
		match-setup
	]
	NumDonne: 1
	first-comment/text: "Matching first and second rounds"
	show main
	Donnes: ranger-donnes texte
	if match-sheet-build?[match-setup]
;	write/lines %t8.pbn donnes	;debug only
	first-comment/text: "Building statistics"
	show main
	NS-total: EW-total: 0
	NumDonne: 1
	report-setup
	excuter-stats donnes
	write/lines %report.txt report-sheet
	if match-sheet-build?[write/lines match-sheet match]
	quit
]
view Main: layout/size[
	first-comment: h2 280 "           "
	second-comment: h2 280 "           "
	at 20x130  Chk: check at 40x128 h2 "making match sheet"
	at 20x160 bt-choix: button 150 "Choisir un fichier log" [deal-analyze]
]300x200
]